LIBRARY ieee;
USE     ieee.std_logic_1164.all ;
USE     ieee.std_logic_arith.all ;
USE     ieee.std_logic_signed.all ;
USE     ieee.std_logic_unsigned.all ;

ENTITY design2 IS
   PORT( nclr, nload, ent, enp   : IN std_logic ;
         d, c, b, a, clk         : IN std_logic ;
         qd, qc, qb, qa, rco	 : OUT std_logic
   );
END design2;


ARCHITECTURE behavioral OF design2 IS
BEGIN
   count: PROCESS( nclr, clk, ent, enp )
      VARIABLE icount : unsigned(3 DOWNTO 0) ;
   BEGIN
      IF (nclr = '0') THEN
         icount := "0000" ;
      ELSIF clk'event and clk='1' THEN
         IF (nload = '0') THEN
             icount := (d,c,b,a) ;
         ELSIF (ent='1' AND enp='1') THEN
             icount :=  icount +  "0001" ;
         END IF;
      END IF;	
      IF (icount = 15 AND ent='1' ) THEN
         rco <= '1' ;
      ELSE
         rco <= '0' ;
      END IF;
      qa <= std_logic(icount(0)) ;
      qb <= std_logic(icount(1)) ;
      qc <= std_logic(icount(2)) ;
      qd <= std_logic(icount(3)) ;	
   END PROCESS ;	
END behavioral;



library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity testbench is
  
end testbench;

architecture behavioral of testbench is

  signal nclr, nload, ent, enp, d, c, b, a, clk, qd, qc, qb, qa, rco: std_logic;

  component design2
    port( nclr, nload, ent, enp   : IN std_logic ;
          d, c, b, a, clk         : IN std_logic ;
          qd, qc, qb, qa, rco	 : OUT std_logic
   );

  end component;


 begin

   dut: design2
     port map (
       nclr => nclr,
       nload => nload,
       ent => ent,
       enp => enp,
       d => d,
       b => b,
       c => c,
       a => a,
       clk => clk,
       qd => qd,
       qc => qc,
       qb => qb,
       qa => qa,
       rco => rco);


  -----------------------------------------------------------------------------
  --
  -- Processes, etc., for a testbench
  --

  -- repeating process best for generating a clock
  -- Note that the clock was initialized in the definition of its signal
  clkgen : process
  begin
    wait for 10 ns;
    clk <= not clk;
  end process;

   -- For simple waveforms, use "<=" and "after"
   nclr <= '1',
           '0' after 60 ns;


 end behavioral;
